#!/usr/bin/python

import rotnn,  getopt, sys
from string import *

# Default action is rot13...
do_wrotate = 0
do_srotate = 0
do_rotate = 1
r_value = 13

def quit_gracefully():
	print 
	print "Exiting Python Rot13 test script..."
	print
	sys.exit(0)


def print_and_quit():
	print "Usage:"
	print sys.argv[0:1][0], "[-h] [-wsr (value)]  [filename]"
	print "-h :Print this message and quit."
	print "-w value :Wrotate the information by value."
	print "-s value :Srotate the information by value."
	print "-r value :Rotate the information by value."
	print "For more information on [SW]Rotate, please see the README."
	sys.exit(0)


try:
	a_list, z_list = getopt.getopt(sys.argv[1:], "hw:s:r:")
except getopt.error, extra_data:
	print extra_data
	print_and_quit()


if len(a_list) == 0:
	print
	print "Don't forget, you can do a -h for more options..."
	print

for opt_pair in a_list:
	if opt_pair[0] == "-h":
		print_and_quit()
	elif opt_pair[0] == "-w":
		do_wrotate = 1
		do_srotate = 0
		do_rotate = 0
		if opt_pair[1][0] in digits:
			r_value = int(opt_pair[1])
		else:
			print_and_quit()
	elif opt_pair[0] == "-s":
		do_srotate = 1
		do_wrotate = 0
		do_rotate = 0
		if opt_pair[1][0] in digits:
			r_value = int(opt_pair[1])
		else:
			print_and_quit()
	elif opt_pair[0] == "-r":
		do_srotate = 0
		do_wrotate = 0
		do_rotate = 1
		if opt_pair[1][0] in digits:
			r_value = int(opt_pair[1])
		else:
			print_and_quit()
	
if len(z_list) > 1:
	print_and_quit()
elif len(z_list) == 1:
	try:
		f = open(z_list[0], "r")
		z_file = f.readlines()
		for z_entry in z_file:
			if do_rotate:
				print rotnn.rotate(z_entry[:-1], r_value)
			elif do_srotate:
				print rotnn.srotate(z_entry[:-1], r_value)
			elif do_wrotate:
				print rotnn.wrotate(z_entry[:-1], r_value)
	except:
		print "Error working with file -- are you sure it exists?"
		sys.exit(1)
else:
	imp = "spam"
	print "Interactive input - to terminate, enter only a single period."
	while not imp == ".":
		try:
			imp = raw_input("-> ")
		except:
			quit_gracefully()
		else:
			if not (imp == "."):
				if do_rotate:
					imp = rotnn.rotate(imp, r_value)
				elif do_srotate:
					imp = rotnn.srotate(imp, r_value)
				elif do_wrotate:
					imp = rotnn.wrotate(imp, r_value)
				print imp
	quit_gracefully()

			


